
function[w,r,arft]=sspARpsd_realiz1(lg,ord,K,L,N)
%x=output of an IIR with input white Gaussian
%noise of variance 1 and mean zero;a(ord)=coefficients
%with order equal to ord;lg=number of lags for the autocorralation
%function and MUST be at least one larger than the ord;
%ord=order of the AR model; L=desired bins in the spectrum power of 2^n;
%on the command window the plot(w,arft) will plot the PSD;
%K=number of realizations;N=length of IIR output sequence (vector x);
%arft=a LxK matrix with each column representingof the PSD for each
%realization, to plot the average you write: plot(w,sum(arft,2)), the
%number 2 indicates the sumation of columns;the reader can easily change 
%the signal and the IIR filter to fit the desired outputs;
for k=0:K-1
    for n=0:N-1
    x(4)=0;x(3)=0;x(2)=0;x(1)=0;
    x(n+5)=1.3847*x(n+4)-1.5602*x(n+3)+0.8883*x(n+2)-...
    0.4266*x(n+1)+randn;
end;
q=0:N-1;
s=4*sin(0.3*pi*q)+4*sin(0.32*pi*q);
x1=x(1,5:N+4)+s;
r=sasamplebiasedautoc(x1,lg);
m=1:ord;
R=toeplitz(r(1,1:ord));
a=-inv(R)*r(1,2:ord+1)';
w=0:2*pi/L:2*pi-(2*pi/L);
arft(:,k+1)=(1./abs((1+(exp(-j*w'*m)*a)).^2))/lg;
end;
