
function[w,y,e,J,w1]=ssp_lms_norm_signed_regressor(x,dn,mu,M,ep)
%function[w,y,e,J,w1]=ssp_lms_norm_signed_regressor(x,dn,mu,M);
%all quantities are real-valued;
%x=input data to the filter;dn=desired signal;
%M=order of the filter;
%mu=step size;x and dn must be of the same length
N=length(x);
y=zeros(1,N);
w=zeros(1,M);%initialized filter coefficient vector
en=0;
for n=M:N
   x1=x(n:-1:n-M+1);%for each n the vector x1 is 
   %of length M with elements from x in reverse order;
   y(n)=w*x1';
   e(n)=dn(n)-y(n);
   en=en+(abs(e(n)))^2;
   w=w+2*mu*e(n)*sign(x1)/(ep+en); %ep=a small positive number e.g. 0.05;
   w1(n-M+1,:)=w(1,:);
end;
J=e.^2;
%the columns of w1 depict the history of the filter
%coefficients;

