
function[qmin,sigma,q,d]=ssp_pisar_harm_decomp(x,p)
%this function graphs the PSD using Pisarenko
%harmonic decomposition; qmin=minimum eigenvector;
%sigma=noise variance;q=matrix eigenvectors;
%d=diagonal matrix of the eigenvalues by descending
%order;p=number of harmonic present;
r=xcorr(x,'biased');
R=toeplitz(r(:,length(x):length(x)+2*p));
[q,d]=eig(R);
sigma=min(diag(d));
coln=find(diag(d)==sigma);
qmin=q(:,coln);
w=0:2*pi/256:2*pi-(2*pi/256);
plot(w,((abs(1./fft(qmin,256))/abs(1./fft(qmin,256)))),'k');