
function[s,as,ps]=sspBTperiodogram(x,win,per,L)
%[s,as,ps]=sspbtperiodogram(x,win,L)
%window names=hamming,kaiser,hann,rectwin,
%bartlett,tukeywin,blackman,gausswin,nattallwin,triang,blackmanharris;
%L=desired number of points (bins) of the spectrum;
%x=data in row form;s=complex form of the DFT;NOTE:per=the percentage
%of points (length(rxt/2))deleted from the correlation function
%to decrease the edge effect;
rxt=xcorr(x,'biased');
wn=[zeros(1,floor((length(rxt)*per/2)))  ones(1,length(rxt)-(...
    2*floor((length(rxt)*per/2))))  zeros(1,floor((length(rxt)...
    *per/2)))];
rx=rxt.*wn;
if (win==2) w=rectwin(length(rx));
elseif (win==3) w=hamming(length(rx));
elseif (win==4) w=bartlett(length(rx));
elseif (win==5) w=tukeywin(length(rx));
elseif (win==6) w=blackman(length(rx));
elseif (win==7) w=triang(length(rx));
elseif (win==8) w=blackmanharris(length(rx));
end;
rxw=rx.*w';
for m=1:L
    n=1:length(rx);
    s(m)=sum(rxw.*exp(-j*(m-1)*(2*pi/L)*n));
end;
as=((abs(s)).^2/length(x))/norm(w);%as=amplitude spectral density;
ps=atan((imag(s)./(real(s)+eps))/((length(x))/(norm(w)+eps)));%ps=phase spectrum;
  
%To plot as or ps we can use the command: plot(0:2*pi/L:2*pi-(2*pi/L),as);
