
function[s,ast,ps,K]=sspwelchperiodogram(x,win,frac,frac1,L)
%function[as,ps,s,K]=sspwelchperiodogram(x,win,frac,frac1,L);
%x=data; M=section length;
%L=number of samples desired in the frequency domain;
%win=2 means rectwin, number 3 means hamming window;
%see sspbtperiodogram function to add more windows if you desire;
%frac defines the number of data for each section, depending on the data
%length it is recommended the number to vary between 0.2 and 1;
%frac1 defines the overlapping of the sections, it is
%recommended the frac1 to very from 1 (no overlap) to 0.5
%which means a 50% overlap; M<<N=length(x);
if (win==2) w=rectwin(floor(frac*length(x)));
elseif (win==3) w=hamming(frac*length(x));
end;
N=length(x);
M=floor(frac*length(x));
K=floor(floor((N-M+floor(frac1*M)))/floor(frac1*M));%K=number of processings;
s=0;as=0;
for i=1:K
    s=s+fft(x(1,(i-1)*(floor(frac1*M))+1:(i-1)*floor(frac1*M)+M).*w',L);
    as=as+abs(s);
end;
ast=as/(M*K);%as=amplitude spectral density;
ps=atan(imag(s)./real(s))/(M*K);%phase spectral density; 

